module EvalArithExp(eval,readExp,writeExp) where

import Prelude (negate,signum,abs,(+),(-),(*),div)
import IO
import ArithExp
import ArithExpUtil

unary (Neg, e) = negate (eval e)
unary (Sign, e) = signum (eval e)
unary (Abs, e) = abs (eval e)

binary (Plus, e1, e2) = (eval e1) + (eval e2)
binary (Minus, e1, e2) = (eval e1) - (eval e2)
binary (Mult, e1, e2) = (eval e1) * (eval e2)
binary (Div, e1, e2) = div (eval e1) (eval e2)

eval (Value i) = i
eval (Unary u) = unary u
eval (Binary b) = binary b

readExp fname =
	bracket (openFile fname ReadMode) hClose
		(\h -> do read_exp h)

writeExp exp fname =
	bracket (openFile fname WriteMode) hClose
		(\h -> do write_exp exp h)

