open ArithExp

	let rec unary (operator, arg) = match operator with
		  Neg -> - (eval arg)
		| Sign -> let v = (eval arg) in if v >= 0 then v else -v
		| Abs -> abs (eval arg)
	and binary (operator, arg1, arg2) = match operator with
		  Plus -> (eval arg1) + (eval arg2)
		| Minus -> (eval arg1) - (eval arg2)
		| Mult -> (eval arg1) * (eval arg2)
		| Div -> (eval arg1) / (eval arg2)
	and eval exp = match exp with
		  (Value i) -> i
		| (Unary u) -> unary u
		| (Binary b) -> binary b

open ArithExpUtil

	let write exp fname =
		let outstream = open_out_bin fname
		in write_exp exp outstream ;
			close_out outstream

	let read fname =
		let instream = open_in_bin fname in
		let result = read_exp instream in
		close_in instream ; result

